package com.hai.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HighGasOilGunNoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighGasOilGunNoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdIsNull() {
            addCriterion("gas_oil_price_id is null");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdIsNotNull() {
            addCriterion("gas_oil_price_id is not null");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdEqualTo(Long value) {
            addCriterion("gas_oil_price_id =", value, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdNotEqualTo(Long value) {
            addCriterion("gas_oil_price_id <>", value, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdGreaterThan(Long value) {
            addCriterion("gas_oil_price_id >", value, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdGreaterThanOrEqualTo(Long value) {
            addCriterion("gas_oil_price_id >=", value, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdLessThan(Long value) {
            addCriterion("gas_oil_price_id <", value, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdLessThanOrEqualTo(Long value) {
            addCriterion("gas_oil_price_id <=", value, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdIn(List<Long> values) {
            addCriterion("gas_oil_price_id in", values, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdNotIn(List<Long> values) {
            addCriterion("gas_oil_price_id not in", values, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdBetween(Long value1, Long value2) {
            addCriterion("gas_oil_price_id between", value1, value2, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andGasOilPriceIdNotBetween(Long value1, Long value2) {
            addCriterion("gas_oil_price_id not between", value1, value2, "gasOilPriceId");
            return (Criteria) this;
        }

        public Criteria andStoreIdIsNull() {
            addCriterion("store_id is null");
            return (Criteria) this;
        }

        public Criteria andStoreIdIsNotNull() {
            addCriterion("store_id is not null");
            return (Criteria) this;
        }

        public Criteria andStoreIdEqualTo(Long value) {
            addCriterion("store_id =", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdNotEqualTo(Long value) {
            addCriterion("store_id <>", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdGreaterThan(Long value) {
            addCriterion("store_id >", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdGreaterThanOrEqualTo(Long value) {
            addCriterion("store_id >=", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdLessThan(Long value) {
            addCriterion("store_id <", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdLessThanOrEqualTo(Long value) {
            addCriterion("store_id <=", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdIn(List<Long> values) {
            addCriterion("store_id in", values, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdNotIn(List<Long> values) {
            addCriterion("store_id not in", values, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdBetween(Long value1, Long value2) {
            addCriterion("store_id between", value1, value2, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdNotBetween(Long value1, Long value2) {
            addCriterion("store_id not between", value1, value2, "storeId");
            return (Criteria) this;
        }

        public Criteria andOilNoIsNull() {
            addCriterion("oil_no is null");
            return (Criteria) this;
        }

        public Criteria andOilNoIsNotNull() {
            addCriterion("oil_no is not null");
            return (Criteria) this;
        }

        public Criteria andOilNoEqualTo(Integer value) {
            addCriterion("oil_no =", value, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoNotEqualTo(Integer value) {
            addCriterion("oil_no <>", value, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoGreaterThan(Integer value) {
            addCriterion("oil_no >", value, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoGreaterThanOrEqualTo(Integer value) {
            addCriterion("oil_no >=", value, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoLessThan(Integer value) {
            addCriterion("oil_no <", value, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoLessThanOrEqualTo(Integer value) {
            addCriterion("oil_no <=", value, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoIn(List<Integer> values) {
            addCriterion("oil_no in", values, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoNotIn(List<Integer> values) {
            addCriterion("oil_no not in", values, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoBetween(Integer value1, Integer value2) {
            addCriterion("oil_no between", value1, value2, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoNotBetween(Integer value1, Integer value2) {
            addCriterion("oil_no not between", value1, value2, "oilNo");
            return (Criteria) this;
        }

        public Criteria andOilNoNameIsNull() {
            addCriterion("oil_no_name is null");
            return (Criteria) this;
        }

        public Criteria andOilNoNameIsNotNull() {
            addCriterion("oil_no_name is not null");
            return (Criteria) this;
        }

        public Criteria andOilNoNameEqualTo(String value) {
            addCriterion("oil_no_name =", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameNotEqualTo(String value) {
            addCriterion("oil_no_name <>", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameGreaterThan(String value) {
            addCriterion("oil_no_name >", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameGreaterThanOrEqualTo(String value) {
            addCriterion("oil_no_name >=", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameLessThan(String value) {
            addCriterion("oil_no_name <", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameLessThanOrEqualTo(String value) {
            addCriterion("oil_no_name <=", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameLike(String value) {
            addCriterion("oil_no_name like", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameNotLike(String value) {
            addCriterion("oil_no_name not like", value, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameIn(List<String> values) {
            addCriterion("oil_no_name in", values, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameNotIn(List<String> values) {
            addCriterion("oil_no_name not in", values, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameBetween(String value1, String value2) {
            addCriterion("oil_no_name between", value1, value2, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilNoNameNotBetween(String value1, String value2) {
            addCriterion("oil_no_name not between", value1, value2, "oilNoName");
            return (Criteria) this;
        }

        public Criteria andOilTypeIsNull() {
            addCriterion("oil_type is null");
            return (Criteria) this;
        }

        public Criteria andOilTypeIsNotNull() {
            addCriterion("oil_type is not null");
            return (Criteria) this;
        }

        public Criteria andOilTypeEqualTo(Integer value) {
            addCriterion("oil_type =", value, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeNotEqualTo(Integer value) {
            addCriterion("oil_type <>", value, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeGreaterThan(Integer value) {
            addCriterion("oil_type >", value, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("oil_type >=", value, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeLessThan(Integer value) {
            addCriterion("oil_type <", value, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeLessThanOrEqualTo(Integer value) {
            addCriterion("oil_type <=", value, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeIn(List<Integer> values) {
            addCriterion("oil_type in", values, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeNotIn(List<Integer> values) {
            addCriterion("oil_type not in", values, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeBetween(Integer value1, Integer value2) {
            addCriterion("oil_type between", value1, value2, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("oil_type not between", value1, value2, "oilType");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameIsNull() {
            addCriterion("oil_type_name is null");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameIsNotNull() {
            addCriterion("oil_type_name is not null");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameEqualTo(String value) {
            addCriterion("oil_type_name =", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameNotEqualTo(String value) {
            addCriterion("oil_type_name <>", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameGreaterThan(String value) {
            addCriterion("oil_type_name >", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("oil_type_name >=", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameLessThan(String value) {
            addCriterion("oil_type_name <", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameLessThanOrEqualTo(String value) {
            addCriterion("oil_type_name <=", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameLike(String value) {
            addCriterion("oil_type_name like", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameNotLike(String value) {
            addCriterion("oil_type_name not like", value, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameIn(List<String> values) {
            addCriterion("oil_type_name in", values, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameNotIn(List<String> values) {
            addCriterion("oil_type_name not in", values, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameBetween(String value1, String value2) {
            addCriterion("oil_type_name between", value1, value2, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andOilTypeNameNotBetween(String value1, String value2) {
            addCriterion("oil_type_name not between", value1, value2, "oilTypeName");
            return (Criteria) this;
        }

        public Criteria andGunNoIsNull() {
            addCriterion("gun_no is null");
            return (Criteria) this;
        }

        public Criteria andGunNoIsNotNull() {
            addCriterion("gun_no is not null");
            return (Criteria) this;
        }

        public Criteria andGunNoEqualTo(Integer value) {
            addCriterion("gun_no =", value, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoNotEqualTo(Integer value) {
            addCriterion("gun_no <>", value, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoGreaterThan(Integer value) {
            addCriterion("gun_no >", value, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoGreaterThanOrEqualTo(Integer value) {
            addCriterion("gun_no >=", value, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoLessThan(Integer value) {
            addCriterion("gun_no <", value, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoLessThanOrEqualTo(Integer value) {
            addCriterion("gun_no <=", value, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoIn(List<Integer> values) {
            addCriterion("gun_no in", values, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoNotIn(List<Integer> values) {
            addCriterion("gun_no not in", values, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoBetween(Integer value1, Integer value2) {
            addCriterion("gun_no between", value1, value2, "gunNo");
            return (Criteria) this;
        }

        public Criteria andGunNoNotBetween(Integer value1, Integer value2) {
            addCriterion("gun_no not between", value1, value2, "gunNo");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}